您的位置:首页 > 其它

LeetCode_Search in Rotated Sorted Array

2014-10-04 18:16 211 查看
Suppose a sorted array is rotated at some pivot unknown to you beforehand.

(i.e.,
0 1 2 4 5 6 7
might become
4 5 6 7 0 1 2
).

You are given a target value to search. If found in the array return its index, otherwise return -1.

You may assume no duplicate exists in the array.

题目的意思使在一个循环有序数组里面进行查找目标值,若目标值存在,则返回目标值对应的下标,否则返回-1。

自己一开始使没有想到好的解法,在网上搜了一下,大概的思路是一致的:

1)二分查找的方式找到循环数组的转折点,每个人找转折点的解法不同,看了好几个人的,个人感觉这个最靠谱好理解:

int lo=0,hi=n-1;
// Find the index of the smallest value using binary search.
// Loop will terminate since mid < hi, and lo or hi will shrink
// by at least 1.
// Proof by contradiction that mid < hi: if mid==hi, then lo==hi
// and loop would have been terminated.
while(lo<hi){
int mid=(lo+hi)/2;
if(A[mid]>A[hi]) lo=mid+1;
else hi=mid;
}


其实主要的想法就是比较A[mid]和当前数组段两个端点大小,一段到低哪一侧已经是一个有序数组了,那么转折点一定存在于另一侧。

2)找到转折点后这个题目就好做了,最简单的方法就是在转折点两侧分别进行一次二分查找,时间复杂度O(logn)。

class Solution {
public:
int search(int A[], int n, int target) {
int lo=0,hi=n-1;
// Find the index of the smallest value using binary search.
// Loop will terminate since mid < hi, and lo or hi will shrink
// by at least 1.
// Proof by contradiction that mid < hi: if mid==hi, then lo==hi
// and loop would have been terminated.
while(lo<hi){
int mid=(lo+hi)/2;
if(A[mid]>A[hi]) lo=mid+1;
else hi=mid;
}
// lo==hi is the index of the smallest value and also
// the number of places rotated.
int rot=lo;
int index = -1;
index = binarySearch(A, 0, rot-1, target);
if(index == -1){
index = binarySearch(A, rot, n-1, target);
}

return index;
}
private:
int binarySearch(int A[], int head, int tail, int target){
if(A[head]>target||A[tail]<target) return -1;

while(head <= tail){
int mid = (head+tail)/2;

if(A[mid] == target){
return mid;
}
else if(A[mid]>target){
tail = mid-1;
}
else {
head = mid+1;
}
}

return -1;
}
};
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: